//
//   MAKE Magazine Video Podcast: Weekend Projects Special Edition
//   Awesome Electronics Workshop w/ Joe Grand & Bre Pettis
// 
//   Introduction to the Arduino
//
//   When the momentary pushbutton is pressed, the brightness of
//   the LED will throb smoothly between bright and off. When the 
//   button is released, the LED will remain off.
//
//   See associated schematic for wiring diagram!
//
//   Based on "Blink" and "Fading" examples included in the Arduino
//   distribution package
//

int cnt = 0;       // counter for our loop
int val = 0;       // variable for reading the pin status
 
int ledPin = 9;    // LED connected to PWM digital pin 9
int inputPin = 2;  // Pushbutton connected to digital pin 2


void setup() 
{
  pinMode(ledPin, OUTPUT);   // declare LED as output
  pinMode(inputPin, INPUT);  // declare pushbutton as input
}

void loop()
{
  for(cnt = 0 ; cnt <= 255; cnt+=5) // fade in (from min to max) 
  { 
    if (digitalRead(inputPin) == LOW) 
    {
      analogWrite(ledPin, cnt);      // sets the value (range from 0 to 255) 
      delay(30);                     // waits for 30 milli seconds to see the dimming effect 
    }
    else
      analogWrite(ledPin, 0);        // turn LED off                    
  } 

  for(cnt = 255; cnt >=0; cnt-=5)    // fade out (from max to min) 
  {
    if (digitalRead(inputPin) == LOW) 
    { 
      analogWrite(ledPin, cnt); 
      delay(30);
    }
    else
      analogWrite(ledPin, 0);         // turn LED off 
  }
}
